//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <clipbrd.hpp>

#include "TestRE20MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	RE20 = 0;

#ifndef USERICHEDITOLE
	PasteSpecial1->Visible = false;
	Object1->Visible = false;
#endif
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
	if (RE20) {
#ifdef USERICHEDITOLE
		RE20->CloseActiveObjects(false);
#endif
		delete RE20;
		}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
	if (!RE20) {
		RE20 = new TRichEdit20(this);
		RE20->Parent = this;
		RE20->Align = alClient;
		RE20->PlainText = true;
		RE20->AutoUrlDetect = true;
		RE20->OnProtectChange = OnProtectChangeHandler;
		Application->OnIdle = ProcessIdle;

		AnsiString msg;
		msg = "Note: This program was compiled with"
#ifndef USERICHEDITOLE
			"out"
#endif
			" support for OLE.  The Edit | Insert Object and "
			"Edit | Paste Special menu items are functional only "
			"if the program was compiled with OLE support."
			"\r\r"
			"Use the options on the Edit menu to enable/disable "
			"Rich Text Format (RTF) text.  Enable or disable RTF "
			"before loading a file.  If RTF text is not enabled "
			"and you load an RTF file, you will see text that might "
			"look something like this:"
			"\r\r"
			"{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1033{\\"
			"fonttbl {\\f0\\fnil Courier New;}}\\uc1\\pard\\tx672"
			"\\tx1344\\tx2016\\tx2688\\tx3360\\tx4032\\tx4704\\tx5376\\tx6048"
			"\r\r"
			"Well, you get the idea."
			"\r\r"
			"If you would like the RE control to automatically recognize and "
			"link to URLs, enable Edit | Auto URL Detection.  (By default in this "
			"application, this is enabled so that you can <shameless plug> "
			"link to my site for more Rich Edit information.  The site is: "
			"http://home.att.net/~robertdunn/Yacs.html.)"
			"\r\r"
			"Further, if you set the character format of some text to 'Link', "
			"then the cursor will change to a hand when over the link text "
			"*if* (and only if) auto URL detection is enabled."
			"\r\r"
			"Oh, and here is some text with yellow background to demonstrate "
			"setting the background color.  There is no menu option for this "
			"in this example -- see the code."
			"\r\r"
			"Enjoy.";

		RE20->Text = msg;

		// set some text background to yellow
		AnsiString yellowText = "text with yellow background";
		int start, length;
		bool found = RE20->FindTextEx(yellowText, 0,
			TFindOptions() << frDown, start, length);
		if (found) {
			RE20->SelStart = start;
			RE20->SelLength = length;
			RE20->SelAttributes2->BackColor = clYellow;
			}
		RE20->SelStart = 0;
		RE20->SelLength = 0;
		}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::New1Click(TObject *Sender)
{
	RE20->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{
	if (OpenDialog1->Execute())
		RE20->Lines->LoadFromFile(OpenDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Undo1Click(TObject *Sender)
{
	RE20->Undo();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Redo1Click(TObject *Sender)
{
	RE20->Redo();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Cut1Click(TObject *Sender)
{
	RE20->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Copy1Click(TObject *Sender)
{
	RE20->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paste1Click(TObject *Sender)
{
	RE20->PasteFromClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PasteSpecial1Click(TObject *Sender)
{
#ifdef USERICHEDITOLE
	RE20->PasteSpecial();
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Object1Click(TObject *Sender)
{
#ifdef USERICHEDITOLE
	RE20->InsertObject();
#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ProcessIdle(TObject *Sender, bool &Done)
{
	// update edit menu with current undo/redo text
	Undo1->Caption = RE20->UndoName;
	Redo1->Caption = RE20->RedoName;
	TClipboard* cb = new TClipboard;
	bool cbNotEmpty = cb->FormatCount;
	delete cb;
	PasteSpecial1->Enabled = RichText1->Checked && cbNotEmpty;
	Bold1->Checked = RE20->SelAttributes2->Bold != tsNo;
	Bold1->Caption = RE20->SelAttributes2->Bold != tsMaybe ? "&Bold" :
		"Some &Bold";
	Italic1->Checked = RE20->SelAttributes2->Italic != tsNo;
	Italic1->Caption = RE20->SelAttributes2->Italic != tsMaybe ? "&Italic" :
		"Some &Italic";
	Underline1->Checked = RE20->SelAttributes2->Underline != tsNo;
	Underline1->Caption = RE20->SelAttributes2->Underline != tsMaybe ? "&Underline" :
		"Some &Underline";
	Strikeout1->Checked = RE20->SelAttributes2->StrikeOut != tsNo;
	Strikeout1->Caption = RE20->SelAttributes2->StrikeOut != tsMaybe ? "&Strikeout" :
		"Some &Strikeout";
	Superscript1->Checked = RE20->SelAttributes2->SuperScript != tsNo;
	Superscript1->Caption = RE20->SelAttributes2->SuperScript != tsMaybe ? "Su&perscript" :
		"Some Su&perscript";
	Subscript1->Checked = RE20->SelAttributes2->SubScript != tsNo;
	Subscript1->Caption = RE20->SelAttributes2->SubScript != tsMaybe ? "Su&bscript" :
		"Some Su&bscript";
	Link1->Checked = RE20->SelAttributes2->Link != tsNo;
	Link1->Caption = RE20->SelAttributes2->Link != tsMaybe ? "&Link" :
		"Some &Link";
	Protected1->Checked = RE20->SelAttributes2->Protected2 != tsNo;
	Protected1->Caption = RE20->SelAttributes2->Protected2 != tsMaybe ? "&Protected" :
		"Some &Protected";

	TUnderlineType ut = RE20->SelAttributes2->UnderlineType;
	switch (ut) {
		case utUnderline:
			Single1->Checked = true;
			break;
		case utDotted:
			Dotted1->Checked = true;
			break;
		default:
			None1->Checked = true;
		}

	TParaAttributes2* paraFormat = RE20->Paragraph2;
	Bullet1->Checked = paraFormat->Numbering;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichText1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	bool rtf = !mi->Checked;
	mi->Checked = rtf;

	RE20->Clear();
	RE20->PlainText = !rtf;
	PasteSpecial1->Enabled = rtf;
	Object1->Enabled = rtf;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AutoURLDetection1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	// note that the following hoops must be jumped through
	// because you cannot assign a property directly to a property
	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->AutoUrlDetect = mi->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Superscript1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->SuperScript = mi->Checked ? tsYes : tsNo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Subscript1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->SubScript = mi->Checked ? tsYes : tsNo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Bold1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->Bold = mi->Checked ? tsYes : tsNo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Italic1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->Italic = mi->Checked ? tsYes : tsNo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Strikeout1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->StrikeOut = mi->Checked ? tsYes : tsNo;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UnderlineRadioClick(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	mi->Checked = true;

	TUnderlineType ut = utNone;
	if (Single1->Checked) ut = utUnderline;
	else if (Dotted1->Checked) ut = utDotted;

	RE20->SelAttributes2->UnderlineType = ut;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Link1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	RE20->SelAttributes2->Link = isChecked ? tsYes : tsNo;
	// make link visibly different
	RE20->SelAttributes2->Color = isChecked ? clBlue : clWindowText;
	RE20->SelAttributes2->UnderlineType = isChecked ? utUnderline : utNone;
}
//---------------------------------------------------------------------------
static bool AllowProtectedChange = false;	// see next two functions

void __fastcall TForm1::Protected1Click(TObject *Sender)
{
	TMenuItem* mi = dynamic_cast<TMenuItem*>(Sender);
	if (!mi) return; 	// should not happen

	bool isChecked = !mi->Checked;
	mi->Checked = isChecked;

	// note: once protected, text cannot be changed (even programatically)
	// unless the EN_PROTECTED notification messages are handled by the
	// Rich Edit control and the change is allowed -- see EN_PROTECTED in
	// the WinAPI help.  here we use a sentinel variable to allow changes
	// only from the menu click
	AllowProtectedChange = true;

	// change attributes to something visibly different
	RE20->SelAttributes2->Color = isChecked ? clRed : clWindowText;
	RE20->SelAttributes2->UnderlineType = isChecked ? utUnderline : utNone;

	// change attribute
	RE20->SelAttributes2->Protected2 = isChecked ? tsYes : tsNo;

	// reset sentinel variable
	AllowProtectedChange = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnProtectChangeHandler(TObject *Sender,
	  int StartPos, int EndPos, bool &AllowChange)
{
	AllowChange = AllowProtectedChange;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Bullet1Click(TObject *Sender)
{
	bool isChecked = !Bullet1->Checked;
	Bullet1->Checked = isChecked;
    RE20->Paragraph2->Numbering = isChecked ? nsBullet : nsNone;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Indent1Click(TObject *Sender)
{
	RE20->Paragraph2->FirstIndent2 =
		RE20->Paragraph2->NextTab(RE20->Paragraph2->FirstIndent2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Outdent1Click(TObject *Sender)
{
	RE20->Paragraph2->FirstIndent2 =
		RE20->Paragraph2->PriorTab(RE20->Paragraph2->FirstIndent2);
}
//---------------------------------------------------------------------------

